/******************************************************************************
 *
 * BixelViewDoc.cpp - implementation of the CBixelViewDoc class
 *
 * *** See BixelViewDoc.h for more information
 *
 *  01/19/02: D. Hazen--File created (wizard)
 *  02/07/02: D. Hazen--Added something else
 *  02/16/02: D. Hazen--I have no clue of any of these dates
 *  03/19/02: D. Hazen--Finished adding comments to the file
 *****************************************************************************/

#include "stdafx.h"
#include "BixelView.h"

#include "BixelViewDoc.h"
#include "ArcBall.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAspectView

CAspectView::CAspectView()
{
    m_Up[0] = 0.0;
    m_Up[1] = 1.0;
    m_Up[2] = 0.0;
    m_Eye[0] = 0.0;
    m_Eye[1] = 0.0;
    m_Eye[2] = 4.0;  
    m_Ctr[0] = 0.0;
    m_Ctr[1] = 0.0;
    m_Ctr[2] = 0.0;
    m_ArcBall = new CArcBall();
    m_ArcBall->BallValue();
}

CAspectView::~CAspectView() 
{
    // add deletion code here
}

// Code to draw the rectangle on the screen
void CAspectView::OnDrawGL(CRect windowRect) 
{
    glViewport(0, 0, windowRect.right, windowRect.bottom);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    // draws the circle and the current drag stats
    m_ArcBall->BallDraw(1);
    glPushMatrix();
    
    GLfloat m[16];
    // multiply by the rotation matrix created by the arcball
    glGetFloatv(GL_MODELVIEW_MATRIX,m);
    glMultMatrixf(m_ArcBall->GetMatrix());
    // do the actual drawing of the texture (see BuildTexture in 
    // CBixelViewView
    ::glCallList(1);

    glPopMatrix();
    
}

// Zoom in the view (object is at (0,0,0), eye is at (0,0,4)
// so zooming in just involves reducing the z component of
// the eye location, we update the matrices in the CBixelViewView
// class
void CAspectView::OnZoomIn()
{
    m_Eye[2] = 0.9*m_Eye[2];
}

// Zooms out (see zoom in for explanation)
void CAspectView::OnZoomOut() 
{
    m_Eye[2] = 1.1*m_Eye[2];
}

/////////////////////////////////////////////////////////////////////////////
// CBixelViewDoc

IMPLEMENT_DYNCREATE(CBixelViewDoc, CDocument)

BEGIN_MESSAGE_MAP(CBixelViewDoc, CDocument)
	//{{AFX_MSG_MAP(CBixelViewDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_SEND_MAIL, OnFileSendMail)
	ON_UPDATE_COMMAND_UI(ID_FILE_SEND_MAIL, OnUpdateFileSendMail)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBixelViewDoc construction/destruction

CBixelViewDoc::CBixelViewDoc()
{
	// TODO: add one-time construction code here
    m_CurrentView = new CAspectView();
}

CBixelViewDoc::~CBixelViewDoc()
{
}

BOOL CBixelViewDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CBixelViewDoc serialization

void CBixelViewDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBixelViewDoc diagnostics

#ifdef _DEBUG
void CBixelViewDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBixelViewDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBixelViewDoc commands


