/******************************************************************************
 *
 * BixelViewDoc.cpp - implementation of the CBixelViewDoc class
 *
 * *** See BixelViewDoc class definition for more information
 *
 *  01/19/02: D. Hazen--File created (wizard)
 *  02/07/02: D. Hazen--Added something else
 *  02/16/02: D. Hazen--I have no clue of any of these dates
 *  03/19/02: D. Hazen--Finished adding comments to the file
 *****************************************************************************/

/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BIXELVIEWDOC_H__5C6F6E4D_3299_11D6_9F9F_00105A17CA6F__INCLUDED_)
#define AFX_BIXELVIEWDOC_H__5C6F6E4D_3299_11D6_9F9F_00105A17CA6F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Texture.h"
#include "ArcBall.h"

class CAspectView : public CObject 
{
    // class that keeps track of what to display and how we're looking
    // at the scene in OpenGL (an argument could be made that this should
    // be a part of the view instead of the document, but after debating
    // with myself I decided to put it here so deal with it)

    // method definitions
public:
    CAspectView();
    ~CAspectView();
    // do the actual drawing of the object on the screen
    void OnDrawGL(CRect windowRect);
    // member definitions
public:
    // zoom in view
	void OnZoomIn();
    // zoom out view
    void OnZoomOut();
    // eye location
    GLdouble m_Eye[3];
    // point we are looking at
    GLdouble m_Ctr[3];
    // up vector
    GLdouble m_Up[3];
    // texture used to texture map our square
    CTexture m_Texture;
    // Arcball used to rotate our view in 3 dimensions
    CArcBall * m_ArcBall;
};

// Again, I would suggest looking at the Scribble tutorial if you
// don't understand the View/Document programming concept.
// The main key to this document class is that it holds a
// CAspectView member which holds all of the information about
// what we're looking at in each window.
class CBixelViewDoc : public CDocument
{
protected: // create from serialization only
	CBixelViewDoc();
	DECLARE_DYNCREATE(CBixelViewDoc)

// Attributes
public:
    CAspectView * m_CurrentView;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBixelViewDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBixelViewDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBixelViewDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BIXELVIEWDOC_H__5C6F6E4D_3299_11D6_9F9F_00105A17CA6F__INCLUDED_)
